package com.itron.i9bledemo;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.company.i9sslclient.bluetooth.DeviceInfo;
import com.company.i9sslclient.lib.Logger;
import com.company.i9sslclient.listener.DeviceClick;

import java.util.List;

import androidx.cardview.widget.CardView;
import androidx.recyclerview.widget.RecyclerView;


/**
 * Created by libeker on 17/8/13.
 */

public class DeviceAdapter extends RecyclerView.Adapter<RecyclerView.ViewHolder>{
    private final String TAG = DeviceAdapter.class.getName();

    private Context mContext;
    private List<DeviceInfo> areaBeanList;
    private DeviceClick mDeviceClick;
    private LinearLayout.LayoutParams layoutParams;
    private boolean clicked;
    Logger logger  = Logger.getInstance(DeviceAdapter.class);

    public DeviceAdapter(Context mContext, List<DeviceInfo> areaBeanList, DeviceClick deviceClick) {
        this.mContext = mContext;
        this.areaBeanList = areaBeanList;
        this.mDeviceClick = deviceClick;
        layoutParams = new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT);
        clicked = false;
    }

    public void setData(List<DeviceInfo> areaBeanList){
        if ( this.areaBeanList.size() > 0){
            this.areaBeanList.clear();
        }

        this.areaBeanList.addAll(areaBeanList);
        notifyDataSetChanged();
    }


    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        return new FunctionViewHolder(LayoutInflater.from(mContext).inflate(R.layout.cardview_device_item,null,false));
    }
    @Override
    public void onBindViewHolder(RecyclerView.ViewHolder holder, final int position) {
        final FunctionViewHolder viewHolder = (FunctionViewHolder)holder;

        final DeviceInfo deviceInfo = areaBeanList.get(position);

        logger.debug("onBindViewHolder position: "+position);
        logger.debug("onBindViewHolder deviceInfo.getIdentifier(): "+deviceInfo.getIdentifier());

        viewHolder.tv.setText(deviceInfo.getIdentifier());
        viewHolder.tv_explain.setText(deviceInfo.getName());
        viewHolder.ll_root.setLayoutParams(layoutParams);
        viewHolder.cardView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                logger.error("clicked: "+clicked);

//                if (!clicked){
//                    clicked = true;
                    mDeviceClick.onClick(position);
//                }else {
//                    Toast.makeText(mContext,R.string.clicked,Toast.LENGTH_SHORT).show();
//                }


            }
        });
        }

    @Override
    public int getItemCount() {
        return areaBeanList.size();
    }


    public boolean isClicked() {
        return clicked;
    }

    public void setClicked(boolean clicked) {
        this.clicked = clicked;
    }

    class FunctionViewHolder extends  RecyclerView.ViewHolder{

        LinearLayout ll_root;
        CardView cardView;
        TextView tv;
        TextView tv_explain;

        public FunctionViewHolder(View itemView) {
            super(itemView);

            cardView = (CardView)(itemView.findViewById(R.id.cardView));
            ll_root = (LinearLayout)(itemView.findViewById(R.id.ll_root));
            tv = (TextView) (itemView.findViewById(R.id.tv_mac));
            tv_explain = (TextView) (itemView.findViewById(R.id.tv_name));
        }
    }
}
