package com.itron.i9bledemo;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.ProgressDialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothManager;
import android.content.ComponentName;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.ServiceConnection;
import android.content.pm.PackageManager;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.text.TextUtils;
import android.view.KeyEvent;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;
import androidx.core.content.ContextCompat;

import com.company.i9sslclient.TLVprocess.Field55Test;
import com.company.i9sslclient.TLVprocess.TlvData;
import com.company.i9sslclient.bean.AIDParameters;
import com.company.i9sslclient.bean.CAPublicKey;
import com.company.i9sslclient.bean.CardInfo;
import com.company.i9sslclient.bean.KernelInfo;
import com.company.i9sslclient.bean.TerminalInfo;
import com.company.i9sslclient.ble.BleController;
import com.company.i9sslclient.bt.BluetoothController;
import com.company.i9sslclient.constant.KeyType;
import com.company.i9sslclient.lib.ErrorCode;
import com.company.i9sslclient.lib.Logger;
import com.company.i9sslclient.lib.TradeTag;
import com.company.i9sslclient.lib.Util;
import com.company.i9sslclient.listener.DeviceConnectionListener;
import com.company.i9sslclient.listener.TerminalInfoListstener;
import com.company.i9sslclient.service.BluetoothLeService;

import org.json.JSONObject;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import okhttp3.Call;
import okhttp3.Callback;
import okhttp3.FormBody;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;


/**
 *
 */
public class I9OnlenControlActivity extends AppCompatActivity implements View.OnClickListener{


    private MainListener mMainListener;

    private BleController mBluetoothController;

    Spinner sp_command;
    TextView tv_log;

    TextView tv_status;


    Logger logger  = Logger.getInstance(I9OnlenControlActivity.class);

    private BluetoothAdapter mBluetoothAdapter;

    private int keyType;

//    第几个步骤
//    private int bu;
//    蓝牙是否建立了连接
    private boolean isConnected;
    private String mac;
//    private String terminalVersion;

    private TextView tv_key1;
    private EditText et_key1;
//    private int keyType;

    private ExecutorService executorService;
    private BluetoothLeService mBluetoothLeService;
    Button btn_connect;

    private String tradeData;

    private int terminalIType = 0;

    private ProgressDialog downloadProgressDialog;

    @SuppressLint("HandlerLeak")
    private Handler mHandler = new Handler(){
        @Override
        public void handleMessage(Message msg) {
            super.handleMessage(msg);

            switch (msg.what){
                case -0x1000:
                    String progress = (String) (msg.obj);
                    logger.error("msgPro: "+ progress);
                    if (downloadProgressDialog == null){
                        downloadProgressDialog = new ProgressDialog(I9OnlenControlActivity.this);
                        downloadProgressDialog.setCancelable(false);
                        downloadProgressDialog.setIndeterminate(false);

                    }
                    downloadProgressDialog.setMessage(getResources().getString(R.string.loading_prgress)+": "+progress+"%");

                    if ("100".equals(progress)){
                        if (downloadProgressDialog != null){
                            if (downloadProgressDialog.isShowing()){
                                downloadProgressDialog.dismiss();
                                downloadProgressDialog = null;
                            }
                        }
                    }else {

                        if (!downloadProgressDialog.isShowing()) {
                            downloadProgressDialog.show();
                        }
                    }
                    break;
                case -2:
                    break;
                case -1:
                    break;
                default:
                    String tmp = tv_log.getText().toString().trim();
                    int tmpLen = tmp.length();
                    if (tmpLen > 10240){
                        tmp = tmp.substring(tmpLen/2);
                    }
                    String log = tmp+"\n"+(String)msg.obj;
                    tv_log.setText(log);
                    break;
            }
        }
    };


    // Code to manage Service lifecycle.
    private final ServiceConnection mServiceConnection = new ServiceConnection() {

        @Override
        public void onServiceConnected(ComponentName componentName, IBinder service) {
            mBluetoothLeService = ((BluetoothLeService.LocalBinder) service).getService();
            if (!mBluetoothLeService.initialize()) {
//                Log.e(TAG, "Unable to initialize Bluetooth");
                finish();
            }
            // Automatically connects to the device upon successful start-up initialization.
//            mBluetoothLeService.connect(mDeviceAddress);
            mBluetoothController = BleController.getInstance(I9OnlenControlActivity.this,null,
                    new DeviceConnectionListener(){
                        @Override
                        public void connected() {
                            isConnected = true;
                            tv_status.setText(R.string.connected);
//                            tv_status.setTextColor(getResources().getColor(android.R.color.holo_blue_bright));
                            tv_status.setTextColor(ContextCompat.getColor(I9OnlenControlActivity.this,android.R.color.holo_blue_bright));
                            mHandler.sendMessage(mHandler.obtainMessage(0,"Connect success"));
                            setButtonEnable(true);

                        }
                        @Override
                        public void connectFail() {
                            isConnected = false;
                            tv_status.setText(R.string.disconnected);
//                            tv_status.setTextColor(getResources().getColor(android.R.color.holo_red_dark));
                            tv_status.setTextColor(ContextCompat.getColor(I9OnlenControlActivity.this,android.R.color.holo_red_dark));
                            setButtonEnable(false);
                            mHandler.sendMessage(mHandler.obtainMessage(0,"Connect fail"));
                        }
                        @Override
                        public void disConnected() {
                            isConnected = false;
                            tv_status.setText(R.string.disconnected);
                            tv_status.setTextColor(ContextCompat.getColor(I9OnlenControlActivity.this,android.R.color.holo_red_dark));
                            setButtonEnable(false);
                            mHandler.sendMessage(mHandler.obtainMessage(0,"disConnected"));
                        }
                    },mMainListener,mBluetoothLeService);
            mBluetoothController.connectDevice(mac);

        }

        @Override
        public void onServiceDisconnected(ComponentName componentName) {
            mBluetoothLeService = null;
        }
    };
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_i9_ble_control);
        logger.setDebug(true);
        Toolbar toolbar = findViewById(R.id.toolbar);

//        setSupportActionBar(toolbar);
        //设置是否有NvagitionIcon（返回图标）
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        toolbar.setNavigationOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                onBackPressed();
            }
        });

        // Use this check to determine whether BLE is supported on the device.  Then you can
        // selectively disable BLE-related features.
        if (!getPackageManager().hasSystemFeature(PackageManager.FEATURE_BLUETOOTH_LE)) {
            Toast.makeText(this, R.string.ble_not_supported, Toast.LENGTH_SHORT).show();
            finish();
        }

        // Initializes a Bluetooth adapter.  For API level 18 and above, get a reference to
        // BluetoothAdapter through BluetoothManager.
        final BluetoothManager bluetoothManager =
                (BluetoothManager) getSystemService(Context.BLUETOOTH_SERVICE);
        mBluetoothAdapter = bluetoothManager.getAdapter();

        // Checks if Bluetooth is supported on the device.
        if (mBluetoothAdapter == null) {
            Toast.makeText(this, R.string.error_bluetooth_not_supported, Toast.LENGTH_SHORT).show();
            finish();
            return;
        }


        logger.setDebug(true);

        executorService = Executors.newFixedThreadPool(1);


        mMainListener = new MainListener();


        isConnected = false;

        tv_log = (TextView) findViewById(R.id.tv_log);
//        tv_log.setMovementMethod(ScrollingMovementMethod.getInstance());

        tv_status = (TextView) findViewById(R.id.tv_status);
        btn_connect = (Button)findViewById(R.id.btn_connect);
        btn_connect.setOnClickListener(this);





        tv_key1 = (TextView) findViewById(R.id.tv_key1);
        et_key1 = (EditText) findViewById(R.id.et_key1);
        et_key1.setText("0");
        setButtonEnable(false);






        sp_command = (Spinner) findViewById(R.id.sp_command);

        String[] command_list = { "Get Device Info","MSR, CHIP, Contactless","Stop"};

        ArrayAdapter adapter_login = new ArrayAdapter<String>(this,
                R.layout.command_spinner_dropdown_item, command_list);
        adapter_login.setDropDownViewResource(R.layout.command_spinner_dropdown_item);

        sp_command.setAdapter(adapter_login);
        sp_command.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> adapterView, View view, int i, long l) {
//                logger.error("positon: "+i);
            }

            @Override
            public void onNothingSelected(AdapterView<?> adapterView) {

            }
        });


        Spinner sp_key_type = (Spinner) findViewById(R.id.sp_key_type);
        sp_key_type.setVisibility(View.GONE);
        String[] keyList = { "DUKPT","MK/SK","FixKey"};
        ArrayAdapter keyAdapter = new ArrayAdapter<String>(this,
                android.R.layout.simple_spinner_item, keyList);
        keyAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        sp_key_type.setAdapter(keyAdapter);
        sp_key_type.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> adapterView, View view, int i, long l) {
                logger.error("onItemSelected i: "+i);
                keyType = i;
                switch (i){
                    case 0:
                        tv_key1.setText("DUKPT Index: ");
                        et_key1.setHint("0-4");
//                        et_key1.setEnabled(true);
                        break;
                    case 1:
                        tv_key1.setText("MK/SK Index: ");
//                        et_key1.setText("0");
                        et_key1.setHint("0-98");
//                        et_key1.setEnabled(false);
                        break;
                    case 2:
                        tv_key1.setText("Data Key Index: ");
                        et_key1.setHint("0-9");
//                        et_key1.setEnabled(true);
                        break;
                    default:
                        break;
                }
            }

            @Override
            public void onNothingSelected(AdapterView<?> adapterView) {
                logger.error("onNothingSelected");
                keyType = 0;
            }
        });



        mac = getIntent().getStringExtra("mac");

        Intent gattServiceIntent = new Intent(this, BluetoothLeService.class);
        bindService(gattServiceIntent, mServiceConnection, BIND_AUTO_CREATE);
    }
    private void setButtonEnable(boolean b){
        btn_connect.setEnabled(b);

    }

    private byte appType;

    // 打开文件管理器选择文件
    private void openFileManager() {
        // 打开文件管理器选择文件
        Intent intent = new Intent(Intent.ACTION_GET_CONTENT);
        intent.setType("*/*");
        intent.addCategory(Intent.CATEGORY_OPENABLE);
        startActivityForResult(intent, 0x666);
    }


    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        switch (requestCode) {
            /*
            case REQUEST_CONNECT_DEVICE_SECURE:
                // When DeviceListActivity returns with a device to connect
                if (resultCode == Activity.RESULT_OK) {
                    connectDevice(data, true);
                }
                break;
            case REQUEST_CONNECT_DEVICE_INSECURE:
                // When DeviceListActivity returns with a device to connect
                if (resultCode == Activity.RESULT_OK) {
                    connectDevice(data, false);
                }
                break;
                */
            case BluetoothController.REQUEST_ENABLE_BT:
                // When the request to enable Bluetooth returns
                if (resultCode == Activity.RESULT_OK) {
                    // Bluetooth is now enabled, so set up a chat session
                } else {
                    // User did not enable Bluetooth or an error occurred
                    Toast.makeText(this, R.string.bt_not_enabled_leaving, Toast.LENGTH_SHORT).show();
                    finish();
                }
                break;
            case 0x666:
                if (data != null) {
                    Uri uri = data.getData();
                    if (uri != null) {

                        logger.error("uri: "+uri.toString());

                        try {
                            InputStream fileInputStream = getContentResolver().openInputStream(uri);
                            InputStream inputStream = getContentResolver().openInputStream(uri);
                            new Thread(new UpgradeRunnable(fileInputStream,inputStream, appType)).start();

                        } catch (Exception e) {
                            e.printStackTrace();
                        }

                    }
                }
                break;
            default:
                break;
        }
    }
    @Override
    public void onStart() {
        super.onStart();

        // If BT is not on, request that it be enabled.
        // setupChat() will then be called during onActivityResult
        if (!mBluetoothAdapter.enable()) {
            Intent enableIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
            startActivityForResult(enableIntent, BluetoothController.REQUEST_ENABLE_BT);
            // Otherwise, setup the chat session
        }
    }


    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK){
            setResult(0x23);
            finish();
        }
        return super.onKeyDown(keyCode, event);
    }


    @Override
    protected void onDestroy() {
        super.onDestroy();


        try {
            logger.error("onDestroy");
            mHandler.removeCallbacksAndMessages(null);
            mBluetoothLeService.disconnect();
            mBluetoothLeService.close();
            unbindService(mServiceConnection);
//            if (mPL2303CommandController != null){
//                mPL2303CommandController.releaseDevice();
//                mPL2303CommandController = null;
//            }
            mBluetoothLeService = null;
            if (mBluetoothController != null) {

                mBluetoothController.scanLeDevice(false);
                mBluetoothController.close();
                mBluetoothController.unRegisterReceiver();

                mBluetoothController = null;
            }

            executorService.shutdownNow();
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    @Override
    public void onClick(View view) {
        switch (view.getId()){
            case R.id.btn_connect:
                tv_log.setText("");
                switch (sp_command.getSelectedItemPosition()){
                    case 0:
                        logger.error("Get device info");
                        new Thread(){
                            @Override
                            public void run() {
                                mBluetoothController.getTerminalInfo();
                            }
                        }.start();
                        break;
                    case 1:
                        logger.error("MSR, CHIP, Contactless");
                        showInputDialog();
                        break;
                    case 2:
                        logger.error("Stop");
                        new Thread(){
                            @Override
                            public void run() {
                                mBluetoothController.stopTrade();
                            }
                        }.start();
                        break;
                    default:
                        break;
                }
                break;
            default:
                break;
        }
    }


    private final class MainListener implements TerminalInfoListstener {
        @Override
        public void onlineResponse(int code, byte[] rescript, byte[] data) {
            StringBuffer sb = new StringBuffer();
            sb.append("sendOnlineProcessResult code: "+code);
            sb.append("rescript: "+Util.BinToHex(rescript));
            sb.append("data: "+Util.BinToHex(data));

            logger.error(sb.toString());
            mHandler.sendMessage(mHandler.obtainMessage(0, sb.toString()));
        }
        @Override
        public void onSendApdu(List<byte[]> lists) {
            StringBuffer sb = new StringBuffer();
            sb.append("onAPDUResponsedata");

            if ((lists != null) && (lists.size() > 0)){
                int size = lists.size();
                for (int i=0;i<size;i++){
                    sb.append("\n"+i+" : "+Util.BinToHex(lists.get(i)));
                }
            }
            mHandler.sendMessage(mHandler.obtainMessage(0,new SimpleDateFormat("HH:mm:ss:SSS ").format(new java.util.Date())+"onGetTerminalDateTime\n"+sb.toString()));
        }
        @Override
        public void onEncryptedData(byte[] data,String ksn) {
            StringBuffer sb = new StringBuffer();
            sb.append("onEncryptedData:" + Util.BinToHex(data));
            if(ksn !=null){
                sb.append("ksn:" + ksn);
            }
            logger.error(sb.toString());
            mHandler.sendMessage(mHandler.obtainMessage(0,sb.toString()));
        }
        @Override
        public void onPowerOnAPDU(int i, byte[] bytes) {
            StringBuffer sb = new StringBuffer();
            sb.append("onPowerOnAPDU");
            sb.append("\ncardType: "+i);
            sb.append("\ndata: "+Util.BinToHex(bytes));
            mHandler.sendMessage(mHandler.obtainMessage(0,new SimpleDateFormat("HH:mm:ss:SSS ").format(new java.util.Date())+sb.toString()));

        }

        @Override
        public void onGetBatteryPower(int i) {
            StringBuffer sb = new StringBuffer();
            sb.append("batterypower: "+i);
            mHandler.sendMessage(mHandler.obtainMessage(0,new SimpleDateFormat("HH:mm:ss:SSS ").format(new java.util.Date())+"onBatteryPower\n"+sb.toString()));

        }

        @Override
        public void onGetTerminalDateTime(String termianlTime) {
            StringBuffer sb = new StringBuffer();
            sb.append("termianlTime: "+termianlTime);
            mHandler.sendMessage(mHandler.obtainMessage(0,new SimpleDateFormat("HH:mm:ss:SSS ").format(new java.util.Date())+"onGetTerminalTime\n"+sb.toString()));

        }
        @Override
        public void onGetTerminalStatus(int status) {
            StringBuffer sb = new StringBuffer();
            sb.append("onGetTerminalStatus status: "+status);
            mHandler.sendMessage(mHandler.obtainMessage(0,new SimpleDateFormat("HH:mm:ss:SSS ").format(new java.util.Date())+"onGetTerminalStatus\n"+sb.toString()));

        }

        @Override
        public void onUserImport(String s) {
            StringBuffer sb = new StringBuffer();
            sb.append("onUserImport : "+s);
            mHandler.sendMessage(mHandler.obtainMessage(0,new SimpleDateFormat("HH:mm:ss:SSS ").format(new java.util.Date())+"onGetTerminalStatus\n"+sb.toString()));

        }

        @Override
        public void onCardInfoImport(String s, String s1) {
            StringBuffer sb = new StringBuffer();
            sb.append("onCardInfoImport : "+s);
            sb.append("onCardInfoImport : "+s1);
            mHandler.sendMessage(mHandler.obtainMessage(0,new SimpleDateFormat("HH:mm:ss:SSS ").format(new java.util.Date())+"onGetTerminalStatus\n"+sb.toString()));

        }

        @Override
        public void onGetTerminalInfo(TerminalInfo devInfo) {
            StringBuffer sb = new StringBuffer();
            sb.append("onGetTerminalInfo");
            if (18 == devInfo.getTerminalType()){
                sb.append("\nModel Name: " + "i9");
            }else {
                sb.append("\nterminalType: " + devInfo.getTerminalType());
            }
            sb.append("\nTSN: "+devInfo.getTerminalNo());

            if (devInfo.getKernelVer() != null) {
                sb.append("\nKernel Version: " + devInfo.getKernelVer());
            }
            if (devInfo.getSoftVersion() != null) {
                sb.append("\nApplicatin Version: " + devInfo.getSoftVersion());
            }
            if (devInfo.getFirmwareVer() != null) {
                sb.append("\nFirmware Version: " + devInfo.getFirmwareVer());
            }
            if (devInfo.getHardwareVer() != null) {
                sb.append("\nHardware Version: " + devInfo.getHardwareVer());
            }
            if (devInfo.getSoftVersionDate() != null) {
                sb.append("\nSoftware Date: " + devInfo.getSoftVersionDate());
            }
            if (devInfo.getTsn() != null) {
                sb.append("\nSN: " + devInfo.getTsn().toLowerCase());
            }

            if (devInfo.getKernelVersion() != null) {
                sb.append("\nkernelVersion: " + devInfo.getKernelVersion());
            }
            if (devInfo.getBluetoothName() != null) {
                sb.append("\nbluetoothName: " + devInfo.getBluetoothName());
            }
            if (devInfo.getBluetoothMAC() != null) {
                sb.append("\nbluetoothMAC: " + devInfo.getBluetoothMAC());
            }
            if (devInfo.getBluetoothVersion() != null) {
                sb.append("\nbluetoothVersion: " + devInfo.getBluetoothVersion());
            }
            if (devInfo.getProtocolType() != null) {
                sb.append("\nprotocolType: " + devInfo.getProtocolType());
            }
            if (devInfo.getMerchaantNo() != null) {
                sb.append("\nmerchaantNo: " + devInfo.getMerchaantNo());
            }
            if (devInfo.getOperationMode() != null) {
                sb.append("\nOperationMode: " + devInfo.getOperationMode());
            }
            if(devInfo.getLanguage() !=null){
                sb.append("\nLanguage: " + devInfo.getLanguage());
            }
            mHandler.sendMessage(mHandler.obtainMessage(0,new SimpleDateFormat("HH:mm:ss:SSS ").format(new java.util.Date())+"onGetTerminalInfo\n"+sb.toString()));
        }

        @Override
        public void onGetKernelInfo(KernelInfo kernelInfo) {

        }

        @Override
        public void onTimeOut() {
            mHandler.sendMessage(mHandler.obtainMessage(0,new SimpleDateFormat("HH:mm:ss:SSS ").format(new java.util.Date())+"onTimeOut"));
//            tv_log.setText("onTimeOut");

        }

        @Override
        public void onGetCardNo(String CardNo) {
            StringBuffer sb = new StringBuffer();
            sb.append("onGetCardNo");
            sb.append("\nCardNo: "+CardNo);
            mHandler.sendMessage(mHandler.obtainMessage(0,new SimpleDateFormat("HH:mm:ss:SSS ").format(new java.util.Date())+"onGetCardNo\n"+sb.toString()));

//            tv_log.setText(sb.toString());
        }

        @Override
        public void onCaculateMac(String mac, String ksn) {
            StringBuffer sb = new StringBuffer();
            sb.append("onCaculateMac: "+mac);

            logger.error(sb.toString());
            mHandler.sendMessage(mHandler.obtainMessage(0, sb.toString()));
        }

        @Override
        public void onGetMerchant(String merchant,String terminalNo) {
            StringBuffer sb = new StringBuffer();
            sb.append("onGetMerchant merchant: "+merchant);
            sb.append("\nonGetMerchant terminalNo: "+terminalNo);

            logger.error(sb.toString());
            mHandler.sendMessage(mHandler.obtainMessage(0, sb.toString()));
        }
        @Override
        public void onPINEntryResult(byte[] pin) {
            StringBuffer sb = new StringBuffer();
            sb.append("onPINEntryResult: "+Util.BinToHex(pin));

            logger.error(sb.toString());
            mHandler.sendMessage(mHandler.obtainMessage(0, sb.toString()));
        }


        @Override
        public void onError(int code, String msg) {
            StringBuffer sb = new StringBuffer();
            sb.append(new SimpleDateFormat("HH:mm:ss:SSS ").format(new java.util.Date())+"onError");
            sb.append("\ncode: "+code);
            sb.append("\nmsg: "+msg);

            logger.error(sb.toString());

            if (code == ErrorCode.DOWNLOAD_PROGRESS_ERROR_CODE_1001){
                mHandler.sendMessage(mHandler.obtainMessage(-0x1000,msg));
            }else if (((byte)code == (byte)0x94)
                    || ((byte)code == (byte)0x95)
                    || ((byte)code == (byte)0xAC)
                    || ((byte)code == (byte)0x01)
            ){
                if (downloadProgressDialog != null){
                    if (downloadProgressDialog.isShowing()){
                        downloadProgressDialog.dismiss();
                        downloadProgressDialog = null;
                    }
                }
            }


            if (code == ErrorCode.ERROR_CODE_205){
                mHandler.sendMessage(mHandler.obtainMessage(0,sb.toString()));

            }else if (code == ErrorCode.ERROR_CODE_207){
                mHandler.sendMessage(mHandler.obtainMessage(0,sb.toString()));

            }else if (code == ErrorCode.ERROR_CODE_208){
                mHandler.sendMessage(mHandler.obtainMessage(ErrorCode.ERROR_CODE_208,sb.toString()));
//                if (versionRunnable != null){
//                    versionRunnable.close();
//                }
            }else if (code == ErrorCode.ERROR_CODE_209){

                mHandler.sendMessage(mHandler.obtainMessage(ErrorCode.ERROR_CODE_209,sb.toString()));
            }else if (code == ErrorCode.ERROR_CODE_501){

                mHandler.sendMessage(mHandler.obtainMessage(-2,""+Long.parseLong(msg,  16)));


            }else {
                mHandler.sendMessage(mHandler.obtainMessage(0,sb.toString()));

            }

        }

        @Override
        public void onWaitingcard() {
            StringBuffer sb = new StringBuffer();
            sb.append("onWaitingcard");

            logger.error(sb.toString());
            mHandler.sendMessage(mHandler.obtainMessage(0,sb.toString()));
        }

        @Override
        public void onWaitingPin() {

            logger.error("onWaitingPin");
            mHandler.sendMessage(mHandler.obtainMessage(0,"onWaitingPin"));
        }


        @Override
        public void onICCardInsertion() {
            StringBuffer sb = new StringBuffer();
            sb.append("onICCardInsertion");

            logger.error(sb.toString());
            mHandler.sendMessage(mHandler.obtainMessage(0,sb.toString()));
        }
        @Override
        public void onNFCCardDetection() {
            StringBuffer sb = new StringBuffer();
            sb.append("onNFCCardDetection");

            logger.error(sb.toString());
            mHandler.sendMessage(mHandler.obtainMessage(0,sb.toString()));
        }

        @Override
        public void onDecryptData(byte[] bytes) {
            StringBuffer sb = new StringBuffer();
            sb.append("bytes:" + Util.BinToHex(bytes));
            logger.error(sb.toString());
            mHandler.sendMessage(mHandler.obtainMessage(0,sb.toString()));
        }

        @Override
        public void onReadCard(CardInfo cardInfo) {
            tradeData = cardInfo.getEMVData();
            logger.error("tradeData： " + tradeData);
            StringBuffer sb = new StringBuffer();
            sb.append("onReadCard");
            if(cardInfo.getControlModel() != null) {
                sb.append("\ncontrolModel: " + cardInfo.getControlModel());
            }
            sb.append("\ncardType: " + cardInfo.getCardType());

            if(cardInfo.getCardexpiryDate() != null) {
                sb.append("\ncardexpiryDate: " + cardInfo.getCardexpiryDate());
            }
            if(cardInfo.getCardNo() != null) {
                sb.append("\ncardNo: " + cardInfo.getCardNo());
            }
            if(cardInfo.getCardName() != null){
                sb.append("\nCardName: " + cardInfo.getCardName());
            }
            logger.error(sb.toString());
            mHandler.sendMessage(mHandler.obtainMessage(0,sb.toString()));


        }

        @Override
        public void onShowLog(String log) {
            logger.error(new SimpleDateFormat("HH:mm:ss:SSS ").format(new java.util.Date())+"onShowLog log: "+log);
            mHandler.sendMessage(mHandler.obtainMessage(0,log));
        }

        @Override
        public void onStopTradeSuccess() {
            logger.error("onStopTradeSuccess");
            mHandler.sendMessage(mHandler.obtainMessage(0,"onStopTradeSuccess"));
        }
        @Override
        public void onExecuteSuccess(int code) {
            logger.error("onExecuteSuccess code: "+code);
            if (code == 14){
                logger.error("app download success");
            }else if (code == 15){
                logger.error("kernel download success");
            }else if (code == 16){
                logger.error("key download success");
            }
            mHandler.sendMessage(mHandler.obtainMessage(0,"onExecuteSuccess code: "+code));

        }
        @Override
        public void onData(int type, int code, byte[]... pin) {
            StringBuffer sb = new StringBuffer();
            sb.append("type: "+type);
            sb.append("\ncode: "+code);
            if (pin != null) {
                int len = pin.length;
                for (int i=0;i<len;i++){
                    sb.append("\n"+i+": "+Util.BinToHex(pin[i]));
                }
            }

            logger.error(sb.toString());
            mHandler.sendMessage(mHandler.obtainMessage(0, sb.toString()));
        }
    }

    private final class UpgradeRunnable implements Runnable{

        private InputStream inputStream;
        private InputStream inputStream2;
        //        下载app kernel类型
        private byte type;

        public UpgradeRunnable(InputStream inputStream, InputStream inputStream2, byte type) {
            this.inputStream = inputStream;
            this.inputStream2= inputStream2;
            this.type = type;
        }

        @Override
        public void run() {

            try {

                int fileLen = inputStream.available();
                logger.error("onResponse onDownloadSuccess fileLen: "+fileLen);

                StringBuffer tradeDataStr = new StringBuffer();



                //                                程序类型
                if (type == 0) {
                    tradeDataStr.append("5F01").append("01").append("00");
                }else if (type == 1) {
                    tradeDataStr.append("5F01").append("01").append("01");
                }

//                        String fileName = "M6Pluz_APP_Sign.bin";
//                        InputStream is = getAssets().open(fileName);

//                        int len = fileLen;
                logger.error("Firmware update fileLen: "+fileLen);
//                                    程序文件长度
                tradeDataStr.append("5F02").append("0"+String.valueOf(fileLen).length()).append(Util.BinToHex(String.valueOf(fileLen).getBytes()));
                tradeDataStr.append("5F03").append("04").append(Util.loadCRC32(inputStream));
                String tagPre = tradeDataStr.toString();
                logger.error("Firmware update data: "+tradeDataStr.toString());
                mBluetoothController.firmwareUpdateRequest(Util.HexToBin(tradeDataStr.toString()),inputStream2,fileLen,tagPre,type);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }


    private void showInputDialog() {
        /*@setView 装入一个EditView
         */
       AlertDialog.Builder inputDialog =
               new AlertDialog.Builder(this);
        View dialogView = View.inflate(this, R.layout.activity_custom, null);

        new Thread(){
            @Override
            public void run() {
                StringBuffer tradeDataStr = new StringBuffer();

                tradeDataStr.append(TradeTag.TAG_1F01).append("01").append("71");

                StringBuffer key = new StringBuffer();
                key.append(Util.toHexString(keyType+1));
                String keyIndexStr = et_key1.getText().toString().trim();
                if (TextUtils.isEmpty(keyIndexStr)){
                    runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            Toast.makeText(I9OnlenControlActivity.this,"key index can not be empty",Toast.LENGTH_SHORT).show();
                        }
                    });
                    return;
                }
                key.append(Util.toHexString(Integer.valueOf(keyIndexStr)));
                logger.error("key: "+key.toString());
                //    控制标识 印尼 AA020000
                // 明文数据 10000000
                // 磁道加密 卡号掩码 55域不加密 86640000
                // 磁道加密 卡号加密 55加密 CA650000
                tradeDataStr.append(TradeTag.TAG_1F02).append("04").append("10000000");
                // 01 DUKEP 02 MK/SK
                // 00 key index
                tradeDataStr.append(TradeTag.TAG_1F04).append("06").append("010100000240");
                //    系统时间
                String date = Util.getCurrentDate()+Util.getCurrentTime();
                logger.error("date: "+date);
                tradeDataStr.append(TradeTag.TAG_1F03).append("07").append(date);
                //   下发随机数
                tradeDataStr.append(TradeTag.TAG_1F07).append("03").append("313233");

                int amount = 100;
                String amountStr = String.valueOf(amount);
                String lenStr  = Util.toHexString(amountStr.length());
                logger.error("Util.BinToHex(amountStr.getBytes()): "+Util.BinToHex(amountStr.getBytes()));
                tradeDataStr.append(TradeTag.TAG_1F08).append(lenStr).append(Util.BinToHex(amountStr.getBytes()));
                String transationType = "03";
                //
                String emvinfo = TradeTag.TAG_9C + "01"+ transationType + TradeTag.TAG_9F1A + "02" +"0840" +
                        TradeTag.TAG_5F2A + "020840"  + "9a03" + Util.getCurrentDateYY() + "9f2103" + Util.getCurrentTime();
                tradeDataStr.append(TradeTag.TAG_1F09).append(Util.toHexString(emvinfo.length()/2)).append(emvinfo);

                logger.error("tradeDataStr: "+tradeDataStr.toString());
                mBluetoothController.startEmvProcess(50,Util.HexToBin(tradeDataStr.toString()));

            }
        }.start();
    }


}
