package com.itron.i9bledemo;

import android.Manifest;
import android.annotation.TargetApi;
import android.content.Intent;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.os.Build;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.Toast;

import java.util.ArrayList;
import java.util.List;

import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;

import com.company.i9sslclient.dukpt.DukptUtil;
import com.company.i9sslclient.lib.Util;

public class MainActivity extends AppCompatActivity implements View.OnClickListener {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        Toolbar toolbar = findViewById(R.id.toolbar);
        toolbar.setTitle(getResources().getString(R.string.app_name)+"V"+getVersion());

        setSupportActionBar(toolbar);


        if (Build.VERSION.SDK_INT >= 23) {
            checkAndRequestPermission();
        } else {
            initView();
        }

    }

    private void initView(){
        Button btn_i9 = (Button)findViewById(R.id.btn_i9);
        btn_i9.setOnClickListener(this);
        Button btn_i9_seril = (Button)findViewById(R.id.btn_i9_seril);
        btn_i9_seril.setOnClickListener(this);
        Button btn_i9_serilg = (Button)findViewById(R.id.btn_i9_serilg);
        btn_i9_serilg.setOnClickListener(this);
        Button btn_i9_seril_ft232 = (Button)findViewById(R.id.btn_i9_seril_ft232);
        btn_i9_seril_ft232.setOnClickListener(this);
        Button btn_m6 = (Button)findViewById(R.id.btn_m6);
        btn_m6.setOnClickListener(this);
        Button btn_online = (Button) findViewById(R.id.btn_online);
        btn_online.setOnClickListener(this);

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return false;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_device_info) {
            Toast.makeText(this,R.string.app_name,Toast.LENGTH_SHORT).show();
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()){
            case R.id.btn_i9:
                startActivity(new Intent(MainActivity.this,ScanActivity.class));
                break;
            case R.id.btn_i9_seril:
                startActivity(new Intent(MainActivity.this,I9SerialActivity.class));
                break;
            case R.id.btn_i9_serilg:
                startActivity(new Intent(MainActivity.this,I9GSerialActivity.class));
                break;
            case R.id.btn_i9_seril_ft232:
                startActivity(new Intent(MainActivity.this,I9SerialFT232Activity.class));
                break;
            case R.id.btn_m6:
                Intent intent = new Intent(MainActivity.this,ScanActivity.class);
                intent.putExtra("TYPE",1);
                startActivity(intent);
                break;
            case R.id.btn_online:
                 Intent intent1 = new Intent(MainActivity.this,ScanActivity.class);
                intent1.putExtra("TYPE",2);
                startActivity(intent1);
                break;
        }
    }

    private String getVersion(){
        try {
            PackageInfo packageInfo = getPackageManager().getPackageInfo(getPackageName(),0);
            return packageInfo.versionName;
        }catch (Exception e){
            e.printStackTrace();
            return "";
        }
    }

    @TargetApi(Build.VERSION_CODES.M)
    private void checkAndRequestPermission() {
        List<String> lackedPermission = new ArrayList<String>();


        if (!(checkSelfPermission(Manifest.permission.ACCESS_COARSE_LOCATION) == PackageManager.PERMISSION_GRANTED)) {
            lackedPermission.add(Manifest.permission.ACCESS_COARSE_LOCATION);
        }
        if (!(checkSelfPermission(Manifest.permission.ACCESS_FINE_LOCATION) == PackageManager.PERMISSION_GRANTED)) {
            lackedPermission.add(Manifest.permission.ACCESS_FINE_LOCATION);
        }

        // 权限都已经有了，那么直接调用SDK
        if (lackedPermission.size() == 0) {
            initView();

        } else {
            // 请求所缺少的权限，在onRequestPermissionsResult中再看是否获得权限，如果获得权限就可以调用SDK，否则不要调用SDK。
            String[] requestPermissions = new String[lackedPermission.size()];
            lackedPermission.toArray(requestPermissions);
            requestPermissions(requestPermissions, 1024);
        }
    }

    private boolean hasAllPermissionsGranted(int[] grantResults) {
        for (int grantResult : grantResults) {
            if (grantResult == PackageManager.PERMISSION_DENIED) {
                return false;
            }
        }
        return true;
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, String[] permissions, int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        if (requestCode == 1024 && hasAllPermissionsGranted(grantResults)) {
            initView();

        } else {
            finish();

        }
    }
}
