package com.itron.i9bledemo;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.company.i9sslclient.lib.Logger;
import com.company.i9sslclient.listener.DeviceClick;

import java.util.List;

import androidx.cardview.widget.CardView;
import androidx.recyclerview.widget.RecyclerView;


/**
 * Created by libeker on 17/8/13.
 */

public class PortAdapter extends RecyclerView.Adapter<RecyclerView.ViewHolder>{
    private final String TAG = PortAdapter.class.getName();

    private Context mContext;
    private List<String> areaBeanList;
    private DeviceClick mDeviceClick;
    Logger logger  = Logger.getInstance(PortAdapter.class);;

    public PortAdapter(Context mContext, List<String> areaBeanList, DeviceClick deviceClick) {
        this.mContext = mContext;
        this.areaBeanList = areaBeanList;
        this.mDeviceClick = deviceClick;
    }

    public void setData(List<String> areaBeanList){
        if ( this.areaBeanList.size() > 0){
            this.areaBeanList.clear();
        }

        this.areaBeanList.addAll(areaBeanList);
        notifyDataSetChanged();
    }


    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        return new FunctionViewHolder(LayoutInflater.from(mContext).inflate(R.layout.cardview_device_item,null,false));
    }
    @Override
    public void onBindViewHolder(RecyclerView.ViewHolder holder, final int position) {
        final FunctionViewHolder viewHolder = (FunctionViewHolder)holder;

        final String deviceInfo = areaBeanList.get(position);

        logger.error("onBindViewHolder position: "+position);
        logger.error("onBindViewHolder deviceInfo.getIdentifier(): "+deviceInfo);

        viewHolder.tv.setText(deviceInfo);
//        viewHolder.tv_explain.setText(deviceInfo.getName());

        viewHolder.cardView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                logger.error("onBindViewHolder onClick");

//                        Intent intent = new Intent(mContext, IdiomDetailActivity.class);
//                        intent.putExtra(AppConstants.GRADE_INDEX, idiom);
//                        mContext.startActivity(intent);

                mDeviceClick.onClick(position);

            }
        });
        }

    @Override
    public int getItemCount() {
        return areaBeanList.size();
    }



    class FunctionViewHolder extends  RecyclerView.ViewHolder{

        LinearLayout ll_root;
        CardView cardView;
        TextView tv;
        TextView tv_explain;

        public FunctionViewHolder(View itemView) {
            super(itemView);

            ll_root = (LinearLayout)(itemView.findViewById(R.id.ll_root));
            cardView = (CardView) (itemView.findViewById(R.id.cardView));
            tv = (TextView) (itemView.findViewById(R.id.tv_mac));
            tv_explain = (TextView) (itemView.findViewById(R.id.tv_name));
        }
    }
}
