package com.itron.i9bledemo;

import org.junit.Test;

import static org.junit.Assert.*;

import java.util.HashMap;
import java.util.Map;

/**
 * Example local unit test, which will execute on the development machine (host).
 *
 * @see <a href="http://d.android.com/tools/testing">Testing documentation</a>
 */
public class ExampleUnitTest {
    @Test
    public void addition_isCorrect() {
        assertEquals(4, 2 + 2);

        String medalType = "vip";
        IMedalService medalService = MedalServicesFactory.getMedalService(medalType);
        medalService.showMedal();

    }
    public static class MedalServicesFactory {
        private static final Map<String, IMedalService> map = new HashMap<>();
        static {
            map.put("guard", new GuardMedalServiceImpl());
            map.put("vip", new VipMedalServiceImpl());
            map.put("guest", new GuestMedalServiceImpl());
        }
        public static IMedalService getMedalService(String medalType) {
            return map.get(medalType);
        }
    }

    public interface IMedalService {
        void showMedal();
    }
    public static class GuardMedalServiceImpl implements IMedalService {
        @Override
        public void showMedal() {
            System.out.println("展示守护勋章");
        }
    }
    //嘉宾勋章策略实现类
    public static class GuestMedalServiceImpl implements IMedalService {
        @Override
        public void showMedal() {
            System.out.println("嘉宾勋章");
        }
    }
    //VIP勋章策略实现类
    public static class VipMedalServiceImpl implements IMedalService {
        @Override
        public void showMedal() {
            System.out.println("会员勋章");
        }
    }

}
