//
//  I9BluetoochViewController.swift
//  SwiftDemo
//
//  Created by 翔吴 on 2023/5/4.
//

import UIKit

import framei9

class I9BluetoochViewController: UIViewController, UITableViewDelegate, UITableViewDataSource, CompanyDelegate {
        
        func discoverComplete() {
            
        }
        
        func discoverOneDevice(_ peripheral: CBPeripheral!) {
            DispatchQueue.main.async {
                if(!self.bleArr.contains(where: { (item) -> Bool in
                    return item == peripheral})){
                    self.bleArr.append(peripheral)
                    self.tableView.reloadData()
                }
            }
        }
        
        @objc func onError(_ code: Int, msg: String!) {
            
        }
        
        @objc func bleConnectState(_ isConnect: Bool) {
            if (isConnect) {
                print("Success to connect bluetooth")
            }
            else{
                print("bluetooth failed to connect")
            }
        }
        
        
        func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
            return self.bleArr.count
        }
                   
        func numberOfSections(in tableView: UITableView) -> Int {
            return 1
        }
        
        func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
            
            let cellid = "cellid"
            var cell = tableView.dequeueReusableCell(withIdentifier: cellid)
            if cell == nil {
              cell = UITableViewCell(style: .subtitle, reuseIdentifier: cellid)
            }
            let peripheral : CBPeripheral = self.bleArr[indexPath.row]
            cell?.textLabel?.text = peripheral.name
            cell?.textLabel?.font = .systemFont(ofSize: 14)
            cell?.detailTextLabel?.text = peripheral.identifier.uuidString

            return cell!
        }
        
        func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
            let peripheral : CBPeripheral = self.bleArr[indexPath.row];
            let commandVC: I9CommandViewController = I9CommandViewController()
            commandVC.peripheral = peripheral
            self.navigationController?.pushViewController(commandVC, animated: true)
        }

        @IBOutlet weak var tableView: UITableView!
        
        var mangeBase:CompanyBluetoothBaseClass = CompanyBluetoothBaseClass.getInstance()
        var bleArr : Array<CBPeripheral> = []
        
        override func viewDidLoad() {
            super.viewDidLoad()
            
            self.tableView.delegate = self
            self.tableView.dataSource = self
            self.tableView.rowHeight = 75
            self.mangeBase.deviceType = 0
            self.mangeBase.delegate = self
            self.mangeBase.debug = true
        }

        override func viewDidAppear(_ animated: Bool) {
            super.viewDidAppear(animated)
            self.mangeBase.closeDevice()
        }

        @IBAction func searchClicked(_ sender: UIButton) {
            self.mangeBase.searchDevices(self, timeout: 60)
        }
        
        @IBAction func stopClicked(_ sender: UIButton) {
            self.mangeBase.stopSearching()
        }
        

    }
