//
//  ItronClass.h
//  ItronLibrary
//
//  Created by 攀杨 on 2018/8/7.
//  Copyright © 2018年 攀杨. All rights reserved.
//


#import <Foundation/Foundation.h>

@interface TransactionInfo : NSObject
@property (nonatomic,copy)NSString *currencyCode;
@property (nonatomic,copy)NSString *type;
@property(nonatomic,retain)NSString *countryCode;
@end

@interface TradeData : NSObject
@property (nonatomic,copy)NSString *swipeMode;
@property (nonatomic,copy)NSString *sign;
@property (nonatomic,copy)NSString *encryptionAlgorithm;
@property (nonatomic,copy)NSString *swipeTitle;
@property (nonatomic,copy)NSString *pinTitle;
@property (nonatomic,copy)NSString *random;
@property (nonatomic,copy)NSString *cash;
@property (nonatomic,strong)TransactionInfo *transactionInfo;
@property (nonatomic,copy)NSString *extraData;
@property (nonatomic,copy)NSString *displayData;
@end

@interface CardInfo : NSObject
@property (nonatomic,copy)NSString *KSN;
@property (nonatomic,copy)NSString *TSN;
@property (nonatomic,copy)NSString *ControlModel;
@property (nonatomic,copy)NSString *psamNo;
@property (nonatomic,copy)NSString *cardName;
@property (nonatomic,copy)NSString *cardNo;
@property (nonatomic,assign)int cardType;
@property (nonatomic,copy)NSString *nfcCompany;
@property (nonatomic,copy)NSString *cardexpiryDate;
@property (nonatomic,copy)NSString *PAN;
@property (nonatomic,copy)NSString *cardSerial;
@property (nonatomic,copy)NSString *CVM;
@property (nonatomic,copy)NSString *tracks;
@property (nonatomic,copy)NSString *trackLen;
@property (nonatomic,copy)NSString *encryTrack;
@property (nonatomic,copy)NSString *encryTrackLen;
@property (nonatomic,copy)NSString *PIN;
@property (nonatomic,copy)NSString *MAC;
@property (nonatomic,copy)NSString *TUSN;
@property (nonatomic,copy)NSString *icdata;
@property (nonatomic,copy)NSString *random;
@property (nonatomic,copy)NSString *result;
@property (nonatomic,copy)NSString *deninalReason;
@property (nonatomic,copy)NSString *kernelType;
@property (nonatomic,copy)NSString *outcomeParameterSet;
@property (nonatomic,copy)NSString *userInterfaceRequestData;
@property (nonatomic,copy)NSString *errorIndication;
@property (nonatomic,assign)int NFCCardType;
//swipe fail message
@property (nonatomic,copy)NSString *swipeFailMessage;
@property (nonatomic,copy)NSString *serviceCode;
@property (nonatomic,copy)NSString *batteryLevel;
//2023.04.25 add
@property (nonatomic,copy)NSString *dataKSN;
@property (nonatomic,copy)NSString *trackKSN;
@property (nonatomic,copy)NSString *macKSN;
@property (nonatomic,copy)NSString *emvKSN;

@end

@interface TerminalInfo : NSObject

@property (nonatomic,assign)int terminalType;
@property (nonatomic,copy)NSString *SN;
@property (nonatomic,copy)NSString *TSN;
@property (nonatomic,copy)NSString *softVersion;
@property (nonatomic,copy)NSString *softVersionDate;
@property (nonatomic,copy)NSString *bluetoothName;
@property (nonatomic,copy)NSString *bluetoothMAC;
@property (nonatomic,copy)NSString *bluetoothVersion;
@property (nonatomic,copy)NSString *merchaantName;
@property (nonatomic,copy)NSString *merchaantNo;
@property (nonatomic,copy)NSString *psamNo;
//2020.05.28 add kernelVersion、hardwareVersion、firmwareVersion、protocolType、cpuSN
@property (nonatomic,copy)NSString *protocolType;
@property (nonatomic,copy)NSString *kernelVersion;
@property (nonatomic,copy)NSString *hardwareVersion;
@property (nonatomic,copy)NSString *firmwareVersion;
@property (nonatomic,copy)NSString *cpuSN;
//2020.11.26 add customerSN
@property (nonatomic,copy)NSString *customerSN;
//2023.03.09 add operationMode
@property (nonatomic,copy)NSString *operationMode;
//2023.04.25 add
@property (nonatomic,copy)NSString *language;
@end

@interface AIDParameters : NSObject

@property (nonatomic,copy)NSString *AID;
@property (nonatomic,assign)int Asi;
@property (nonatomic,copy)NSString *AppVerNum;
@property (nonatomic,copy)NSString *TacDefault;
@property (nonatomic,copy)NSString *TacOnline;
@property (nonatomic,copy)NSString *TacDecline;
@property (nonatomic,copy)NSString *FloorLimit;
@property (nonatomic,copy)NSString *Threshold;
@property (nonatomic,assign)int MaxTargetPercent;
@property (nonatomic,assign)int TargetPercent;
@property (nonatomic,copy)NSString *TermDDOL;
@property (nonatomic,copy)NSString *vlptranslimit;
@property (nonatomic,copy)NSString *termcvm_limit;
@property (nonatomic,copy)NSString *clessofflinelimitamt;
@property (nonatomic,copy)NSString *otherTLV;
@end

@interface CAPublicKey : NSObject

@property (nonatomic,copy)NSString *RID;
@property (nonatomic,assign)int CAPKI;
@property (nonatomic,assign)int HashInd;
@property (nonatomic,assign)int ArithInd;
@property (nonatomic,copy)NSString *Modul;
@property (nonatomic,copy)NSString *Exponent;
@property (nonatomic,copy)NSString *ExpireDate;
@property (nonatomic,copy)NSString *CheckSum;

@end

@interface DownloadTag : NSObject

@property (nonatomic,copy)NSString *CF;
@property (nonatomic,copy)NSString *PL;
@property (nonatomic,copy)NSString *DT;
@property (nonatomic,copy)NSString *TI;
@property (nonatomic,copy)NSString *VR;
@property (nonatomic,copy)NSString *NA;
@property (nonatomic,copy)NSString *PT;
@property (nonatomic,copy)NSString *PD;
@property (nonatomic,copy)NSString *DO;
@property (nonatomic,copy)NSString *EX;
@property (nonatomic,copy)NSString *PR;
@property (nonatomic,strong)NSData *DownloadData;

@end

