//
//  CompanyToolClass.h
//  CompanyLibrary
//
//  Created by 攀杨 on 2018/8/9.
//  Copyright © 2018年 攀杨. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface CompanyToolClass : NSObject


typedef NS_ENUM(int, KeyType) {
    KeyTypePINkey = 0x01,
    KeyTypeDatakey = 0x02,
    KeyTypeMackey = 0x03,
    KeyTypeKEKkey = 0x10,
    KeyTypeMKkey = 0x11,
    KeyTypeDUKPTkey = 0x12,
    KeyTypeDataTPKkey = 0x82,
};


typedef NS_ENUM(int, EnType) {
    EnTypeTDES = 0,
    EnTypeAES = 1,
};

typedef NS_ENUM(int, KeyLength) {
    KeyLength128 = 16,
    KeyLength192 = 24,
};

/**
 *  Hex string to data
 *  24211D3498FF62AF  -->  <24211D34 98FF62AF>
 *
 *  @param str Hex string
 *
 *  @return data
 */
+ (NSData*)hexToData:(NSString *)str;


/**
 *  Data to Hex string
 *  <24211D34 98FF62AF>  -->  24211D3498FF62AF
 *
 *  @param data data
 *
 *  @return Hex string
 */
+ (NSString *)DataToHex:(NSData *)data;

/**
 String to ASCII
 123 --> 313233
 
 @param hex string
 @return ASCII
 */
+ (NSString *)hexToAsc:(NSString *)hex;

/**
 ASCII to string
 313233 --> 123
 
 @param asc ASCII
 @return String
 */
+ (NSString *)ascToHex:(NSString *)asc;




@end
