//
//  ItronClass.h
//  ItronLibrary
//
//  Created by 攀杨 on 2018/8/7.
//  Copyright © 2018年 攀杨. All rights reserved.
//


#import <Foundation/Foundation.h>

@interface M6PTransactionInfo : NSObject
@property (nonatomic,copy)NSString *currencyCode;
@property (nonatomic,copy)NSString *type;
@property(nonatomic,retain)NSString *countryCode;
@end

@interface M6PTradeData : NSObject
@property (nonatomic,copy)NSString *swipeMode;
@property (nonatomic,copy)NSString *sign;
@property (nonatomic,copy)NSString *encryptionAlgorithm;
@property (nonatomic,copy)NSString *swipeTitle;
@property (nonatomic,copy)NSString *pinTitle;
@property (nonatomic,copy)NSString *random;
@property (nonatomic,copy)NSString *cash;
@property (nonatomic,strong)M6PTransactionInfo *transactionInfo;
@property (nonatomic,copy)NSString *extraData;
@property (nonatomic,copy)NSString *displayData;
@property (nonatomic,copy)NSString *subTitle;
@property (nonatomic,copy)NSString *panAndValidInputControl;
@end

@interface M6PCardInfo : NSObject
@property (nonatomic,copy)NSString *KSN;
@property (nonatomic,copy)NSString *TSN;
@property (nonatomic,copy)NSString *ControlModel;
@property (nonatomic,copy)NSString *psamNo;
@property (nonatomic,copy)NSString *cardName;
@property (nonatomic,copy)NSString *cardNo;
@property (nonatomic,assign)int cardType;
@property (nonatomic,copy)NSString *nfcCompany;
@property (nonatomic,copy)NSString *cardexpiryDate;
@property (nonatomic,copy)NSString *PAN;
@property (nonatomic,copy)NSString *cardSerial;
@property (nonatomic,copy)NSString *CVM;
@property (nonatomic,copy)NSString *tracks;
@property (nonatomic,copy)NSString *trackLen;
@property (nonatomic,copy)NSString *encryTrack;
@property (nonatomic,copy)NSString *encryTrackLen;
@property (nonatomic,copy)NSString *PIN;
@property (nonatomic,copy)NSString *MAC;
@property (nonatomic,copy)NSString *TUSN;
@property (nonatomic,copy)NSString *icdata;
@property (nonatomic,copy)NSString *random;
@property (nonatomic,copy)NSString *result;
@property (nonatomic,copy)NSString *deninalReason;
@property (nonatomic,copy)NSString *kernelType;
@property (nonatomic,copy)NSString *outcomeParameterSet;
@property (nonatomic,copy)NSString *userInterfaceRequestData;
@property (nonatomic,copy)NSString *errorIndication;
@property (nonatomic,assign)int NFCCardType;
//swipe fail message
@property (nonatomic,copy)NSString *swipeFailMessage;
@property (nonatomic,copy)NSString *serviceCode;
@property (nonatomic,copy)NSString *batteryLevel;
//2023.04.25 add
@property (nonatomic,copy)NSString *dataKSN;
@property (nonatomic,copy)NSString *trackKSN;
@property (nonatomic,copy)NSString *macKSN;
@property (nonatomic,copy)NSString *emvKSN;

@end

@interface M6PTerminalInfo : NSObject

@property (nonatomic,copy)NSString *SN;
@property (nonatomic,copy)NSString *TUSN;
@property (nonatomic,copy)NSString *bluetoothName;
@property (nonatomic,copy)NSString *bluetoothMAC;
@property (nonatomic,copy)NSString *bluetoothVersion;
@property (nonatomic,copy)NSString *appVersion;
@property (nonatomic,copy)NSString *appVersionDate;
@property (nonatomic,copy)NSString *kernelVersion;
@property (nonatomic,copy)NSString *kernelVersionDate;
@property (nonatomic,copy)NSString *hardwareVersion;
@property (nonatomic,copy)NSString *softVersion;
//2023.03.09 add operationMode
@property (nonatomic,copy)NSString *operationMode;
//2023.04.25 add 
@property (nonatomic,copy)NSString *language;

@end

@interface M6PAIDParameters : NSObject

@property (nonatomic,copy)NSString *AID;
@property (nonatomic,assign)int Asi;
@property (nonatomic,copy)NSString *AppVerNum;
@property (nonatomic,copy)NSString *TacDefault;
@property (nonatomic,copy)NSString *TacOnline;
@property (nonatomic,copy)NSString *TacDecline;
@property (nonatomic,copy)NSString *FloorLimit;
@property (nonatomic,copy)NSString *Threshold;
@property (nonatomic,assign)int MaxTargetPercent;
@property (nonatomic,assign)int TargetPercent;
@property (nonatomic,copy)NSString *TermDDOL;
@property (nonatomic,copy)NSString *vlptranslimit;
@property (nonatomic,copy)NSString *termcvm_limit;
@property (nonatomic,copy)NSString *clessofflinelimitamt;
@property (nonatomic,copy)NSString *otherTLV;
@end

@interface M6PCAPublicKey : NSObject

@property (nonatomic,copy)NSString *RID;
@property (nonatomic,assign)int CAPKI;
@property (nonatomic,assign)int HashInd;
@property (nonatomic,assign)int ArithInd;
@property (nonatomic,copy)NSString *Modul;
@property (nonatomic,copy)NSString *Exponent;
@property (nonatomic,copy)NSString *ExpireDate;
@property (nonatomic,copy)NSString *CheckSum;

@end



