import 'package:flutter/material.dart';
import 'package:dio/dio.dart';

import 'M6pBleBean.dart';
import 'M6pBleControl.dart';
import 'm6plus.dart';

List<M6pBleDevice> blueList = [];

BleControl bleControl = BleControl();

void main() {
  runApp(const MyApp());
}

class MyApp extends StatelessWidget {
  const MyApp({super.key});

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('I9 and M6Plus'),
        ),
        body: const HomeContent(),
      ),
    );
  }
}

class HomeContent extends StatefulWidget {
  const HomeContent({Key? key}) : super(key: key);

  @override
  _HomeContentState createState() => _HomeContentState();
}

class _HomeContentState extends State<HomeContent> {
  @override
  void initState() {
    super.initState();
  }

  _blueConnect(M6pBleDevice device) async {
    //await device.connect();
    bool isConnect = await bleControl.connectDevice(device);

    //List<ItronBleDevice> services = await device.discoverServices();
    if (isConnect) {
      Navigator.push(context, MaterialPageRoute(builder: (context) {
        return const M6plusView();
      }));
    }
  }

  Widget buildItem(BuildContext context, int index) {
    return TextButton(
        onPressed: () {
          print(index);
          M6pBleDevice device = blueList[index];
          _blueConnect(device);
        },
        child: Text('${blueList[index].name}\n${blueList[index].UUID}'));
  }

  @override
  Widget build(BuildContext context) {
    /*
    return ListView.builder(
      itemCount: blueList.length,
      itemBuilder: (context, index) {
        return ListTile(
          title: Text('${blueList[index]}'),
        );
      },
    );*/

    return Container(
        child: Column(
      children: [
        Expanded(
          //child: Text('123'),
          flex: 20,
          //child: Text('123'),
          child: ListView.separated(
            itemCount: blueList.length,
            itemBuilder: buildItem,
            separatorBuilder: (BuildContext context, int index) =>
                const Divider(),
          ),
        ),
        Expanded(
          flex: 2,
          child: Center(
            child: ElevatedButton(
              child: const Text('search bluetooth'),
              onPressed: () {
                print('start search bluetooth');
                /*
                itronBle.startScan().listen((event) {
                  //print(event);
                });*/
                //scanBle();
                setState(() {
                  blueList = [];
                });
                bleControl.startScan().listen((device) {
                  setState(() {
                    blueList.add(device);
                  });
                  print(device);
                });
              },
            ),
          ),
        ),
        Expanded(
          flex: 2,
          child: Center(
            child: ElevatedButton(
              child: const Text('disconnect bluetooth'),
              onPressed: () {
                bleControl.disconnect();
                // _getHttp();
              },
            ),
          ),
        ),
        const Expanded(
          flex: 1,
          child: Center(),
        ),
      ],
    ));
  }

  _getHttp() async {
    String url = 'https://wx.itron.com.cn/mp4/M6Pluz_APP_Sign.bin';

    Response response = await Dio()
        .get(url, options: Options(responseType: ResponseType.bytes));
    print(response.statusCode);
    if (response.statusCode == 200) {
      print('1111');
      //String data = _arrToStr(response.data);
      // List<int> dataa = response.data;
    }
  }

  String _arrToStr(List<int> arr) {
    String str = '';
    for (int i = 0; i < arr.length; i++) {
      String str1 = arr[i].toRadixString(16);
      if (str1.length != 2) {
        str1 = '0$str1';
      }
      str = str + str1;
    }
    return str.toUpperCase();
  }
}
